package controler;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import model.Alarm;
import model.AlarmList;
import view.AlarmFrame;

public class Controler {
	private AlarmFrame frame;
	private AlarmList alarms;
	public Controler() {
		frame = null;
		alarms = null;
	}
	public void setView(AlarmFrame f) {
		frame = f;
	}
	public void setModel(AlarmList l) {
		alarms = l;
	}
	public void newAlarm() {
		Alarm alarm = new Alarm("nouvelle", "12:00");
		alarms.add(alarm);
		frame.updateAlarmList();
	}
	public void loadAlarms() {
        JFileChooser dlgFichier = new JFileChooser();
        switch (dlgFichier.showOpenDialog(frame)) {
            case JFileChooser.CANCEL_OPTION  :
                break;
            case JFileChooser.APPROVE_OPTION :
                if (alarms.load(dlgFichier.getSelectedFile())) {
                    frame.repaint();
                    frame.updateTitle();
                    frame.allowSaveItem(true);
                } else
                    JOptionPane.showMessageDialog(frame,
                                                  "Un problme est survenu pendant la lecture du fichier.",
                                                  "Alarmes non charges",
                                                  JOptionPane.ERROR_MESSAGE);
                break;
            case JFileChooser.ERROR_OPTION   :
                JOptionPane.showMessageDialog(frame,
                                              "Un problme est survenu lors du choix de fichier.",
                                              "Alarmes non charges",
                                              JOptionPane.ERROR_MESSAGE);
                break;
        }
	}
	public void saveAlarms() {
        if (!alarms.save()) {
            JOptionPane.showMessageDialog(frame,
                                          "Un problme est survenu pendant l'enregistrement.",
                                          "Alarmes non enregistres",
                                          JOptionPane.ERROR_MESSAGE);
        } else {
            frame.updateTitle();
        }
	}
	public void saveAlarmsAs() {
        JFileChooser fileChooser = new JFileChooser();
        switch (fileChooser.showSaveDialog(frame)) {
            case JFileChooser.CANCEL_OPTION  :
                break;
            case JFileChooser.APPROVE_OPTION :
                if (alarms.saveAs(fileChooser.getSelectedFile())) {
                    frame.updateTitle();
                } else {
                    JOptionPane.showMessageDialog(frame,
                                                  "Un problme est survenu pendant l'enregistrement des alarmes.",
                                                  "Alarmes non enregistres",
                                                  JOptionPane.ERROR_MESSAGE);
                }
                break;
            case JFileChooser.ERROR_OPTION   :
                JOptionPane.showMessageDialog(frame,
                                              "Un problme est survenu lors du choix de fichier pour l'enregistrement du dessin.\nLe dessin n'a pas t enregistr.",
                                              "Alarmes non enregistres",
                                              JOptionPane.ERROR_MESSAGE);
                break;
        }
	}
	public void changeAlarm(Alarm alarm, String name, String time) {
		alarm.setName(name);
		alarm.setTime(time);
		frame.updateAlarmList();
	}
	public void removeAlarm(Alarm alarm) {
        alarms.remove(alarm);
		frame.updateAlarmList();
		frame.editorForNewAlarm();

	}
}
