package view;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;

import controler.Controler;
import model.Alarm;
import model.AlarmList;

@SuppressWarnings("serial")
public class MenuBar extends JMenuBar {
    private JMenuItem saveItem;
    private Controler controler;
    public MenuBar(Controler c)  {
        super();
        controler = c;
        JMenu menu;
        JMenuItem item;

        menu = new JMenu("Alerte");
        add(menu);
        item = new JMenuItem("A propos...");
        item.addActionListener((ActionEvent e) -> new AboutDialog());
        menu.add(item);
        menu.addSeparator();
        item = new JMenuItem("Quitter");
        item.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    System.exit(0);
                }
            }
        );
        menu.add(item);
        
        menu = new JMenu("Alarmes");
        add(menu);
        item = new JMenuItem("Nouvelle");
        item.addActionListener((ActionEvent e) -> controler.newAlarm());
        menu.add(item);
        menu.addSeparator();
        item = new JMenuItem("Ouvrir...");
        item.addActionListener((ActionEvent e) -> controler.loadAlarms());
        menu.add(item);
        item = new JMenuItem("Enregistrer");
        item.setEnabled(false);
        saveItem = item;
        item.addActionListener((ActionEvent e) -> controler.saveAlarms());
        menu.add(item);
        item = new JMenuItem("Enregistrer sous...");
        item.addActionListener((ActionEvent e) -> controler.saveAlarmsAs());
        menu.add(item);
    }
    public void allowSaveItem(boolean b) {
    	saveItem.setEnabled(b);
    }
}
